<?php
define('AJAXCHAT_TABLE', 'ajaxchat');
define('AJAXCHAT_STATUS_TABLE', 'ajaxchatusers');
define('AJAXCHAT_HTML', '
<div id="chatbar">
<table style="margin: 0; table-layout: fixed;" width="100%" cellspacing="0" cellpadding="0">
<tr>
<td width="40"><a href="javascript:;" onclick="showChat()"><img src="images/ajaxchat_expand.gif" alt="Expand chat" id="chatbutton"/></a></td>
<td>
<iframe src="chat_frame.php?small" width="100%" height="50" frameborder="no"></iframe>
</td>
</tr>
</table>
</div>
<div id="chatbar" style="display:none;"></div>
<div id="chatplaceholder">
</div>
'."\n");
define('AJAXCHAT_HEAD_HTML', '<link rel="stylesheet" href="ajaxchat_index.css"/>'."\n".'<script type="text/javascript" src="jscripts/ajaxchat_index.js"></script>'."\n");;

// Disallow direct access to this file for security reasons.
if (!defined('IN_MYBB')) {
	die('Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.');
}

function AJAXChat_info() {
	return Array(
		"name" => "MyBB AJAX Chat",
		"description" => "Adds a chat room to every page of your forum",
		"website" => "http://buildism.net/mybbmods",
		"author" => "Buildism",
		"authorsite" => "http://buildism.net/",
		"version" => "2.0",
		"guid" => "97f20d7094cf4c88a86a7db6d2c7b1fe",
		"compatibility" => "18*"
	);
}

function AJAXChat_install() {
	global $db;
	$db->write_query('CREATE TABLE IF NOT EXISTS `'.$db->table_prefix.AJAXCHAT_TABLE.'` (
`uid` int(10) NOT NULL,
`date` int(10) NOT NULL,
`message` varchar(512) NOT NULL,
`id` int(10) NOT NULL AUTO_INCREMENT,
PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8');
	$db->write_query('CREATE TABLE IF NOT EXISTS `'.$db->table_prefix.AJAXCHAT_STATUS_TABLE.'` (
`uid` int(10) NOT NULL,
`active` int(10) NOT NULL,
PRIMARY KEY (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;');
}

function AJAXChat_activate() {
	require_once MYBB_ROOT.'inc/adminfunctions_templates.php';
	find_replace_templatesets('footer', '#'.preg_quote('{$auto_dst_detection}').'#', '{$auto_dst_detection}'.AJAXCHAT_HTML);
	find_replace_templatesets('headerinclude', '#'.preg_quote('{$stylesheets}').'#', '{$stylesheets}'.AJAXCHAT_HEAD_HTML);
}

function AJAXChat_is_installed() {
	global $db;
	return $db->table_exists(AJAXCHAT_TABLE);
}

function AJAXChat_deactivate() {
	global $db;
	require_once MYBB_ROOT.'inc/adminfunctions_templates.php';
	find_replace_templatesets('footer', '#'.preg_quote(AJAXCHAT_HTML).'#', '');
	find_replace_templatesets('headerinclude', '#'.preg_quote(AJAXCHAT_HEAD_HTML).'#', '');
}

function AJAXChat_uninstall() {
	global $db;
	$db->drop_table("ajaxchat", true);
	$db->drop_table("ajaxchatusers", true);
}

$plugins->add_hook('xmlhttp', 'AJAXChat_run_ajax');
$plugins->add_hook('newreply_do_newreply_end', 'AJAXChat_newreply');
$plugins->add_hook('newthread_do_newthread_end', 'AJAXChat_newthread');

function AJAXChat_run_ajax() {
	global $mybb;
	switch($mybb->input['action']) {
		case 'ajaxchat_send':
			$result = AJAXChat_sendChat($mybb->input['message']);
		break;
		case 'ajaxchat_get':
			$result = AJAXChat_getChats(intval($mybb->input['id']), intval($mybb->input['limit']));
		break;
		case 'ajaxchat_status':
			$result = AJAXChat_getStatus();
		break;
		default: return;
	}
	header('Content-Type: text/json');
	echo json_encode($result);
}

function AJAXChat_parseDate($time) {
    if(time() - $time > 86400)
        return date('n/j/y G:i', $time);
    else
        return date('G:i', $time);
}

function AJAXChat_sendChat($message) {
	global $mybb, $db;
	if(!empty($message) && $mybb->user['uid'] > 0) {
		$db->insert_query(AJAXCHAT_TABLE, array('uid' => $mybb->user['uid'], 'message' => $db->escape_string($message), 'date' => time()));
    }
}

function AJAXChat_getChats($id, $limit=20) {
	global $mybb, $db;

	$result = $db->simple_select(AJAXCHAT_TABLE, '*', 'id > "'.($db->escape_string($id)).'"', array('order_by' => 'id', 'order_dir' => 'desc', 'limit' => ($db->escape_string($limit))));
	$id = $db->fetch_field($db->simple_select(AJAXCHAT_TABLE, 'id', '', array('order_by' => 'id', 'order_dir' => 'desc', 'limit' => 1)), 'id');

	$arr = array($id, $db->num_rows($result) + 2);
	
	require_once MYBB_ROOT.'inc/class_parser.php';
	$parser = new postParser();
	
	while($row = $db->fetch_array($result)) {
		$date = AJAXChat_parseDate($row["date"]);
        if($row['uid'] == 0) {
            $name = '<div class="char"></div>';
        }
        else {
            $user = $db->fetch_array($db->simple_select('users', 'username, avatar', 'uid="'.$row["uid"].'"'));
            if($user["avatar"] == "")
                $avatar = "images/default_avatar.png";
            else
                $avatar = $user['avatar'];
            $name = '<img src="'.$avatar.'" width="25" class="char"/><a href="'.get_profile_link($row["uid"]).'" target="_top">'.$user['username'].'</a>';
        }
		$msg = $parser->parse_message($row["message"], array('filter_badwords'=>1, 'allow_mycode'=>1, 'allow_smilies'=>0, 'me_username'=>1, 'nl2br'=>0, 'allow_imgcode'=>0, 'allow_videocode'=>0));
		$arr[] = '<div class="chat"><div class="info"><span class="name">'.$name.'</span> <span class="date">'.$date.'</span></div><div class="message">'.$msg.'</div></div>';
	}

	if($mybb->user['uid'] != 0) {
	    $userExists = $db->query('SELECT * FROM '.$db->table_prefix.AJAXCHAT_STATUS_TABLE.' WHERE uid="'.$mybb->user['uid'].'" LIMIT 1');
	    $userExists = $db->num_rows($userExists);
	    if($userExists == 0) {
	        $db->query('INSERT INTO '.$db->table_prefix.AJAXCHAT_STATUS_TABLE.'(uid, active) VALUES("'.($mybb->user['uid']).'", '.time().')');
	    }
	    else {
	        $db->query('UPDATE '.$db->table_prefix.AJAXCHAT_STATUS_TABLE.' SET active='.time().' WHERE uid="'.($mybb->user['uid']).'"');
	    }
	}
	return $arr;
}

function AJAXChat_getStatus() {
    global $db;
    $result = $db->query('SELECT * FROM '.$db->table_prefix.AJAXCHAT_STATUS_TABLE.' WHERE active > '.(time() - 10));
    $numUsers = $db->num_rows($result);
    $i = 0;
    while($row = $db->fetch_array($result)) {
        $username = $db->fetch_array($db->simple_select('users', 'username', 'uid="'.$row["uid"].'"'));
        $users .= $username['username'];
        if($i != $numUsers-1)
            $users .= ', ';
        $i++;
    }
    return 'In Chat: '.$users;
}

function AJAXChat_newreply() {
	global $mybb, $db, $pid, $tid, $post;
	$url = get_post_link($pid, $tid)."#pid{$pid}";
	$db->insert_query(AJAXCHAT_TABLE, array(
		'uid' => 0,
		'message' => $mybb->user['username'].' posted a reply: [url='.$mybb->settings['bburl'].'/'.$url.']'.$db->escape_string($post['subject']).'[/url]',
		'date' => time()));
}

function AJAXChat_newthread() {
	global $mybb, $db, $tid, $new_thread;
    $url = get_thread_link($tid);
    $db->insert_query(AJAXCHAT_TABLE, array(
    	'uid' => 0,
    	'message' => $mybb->user['username'].' posted a new thread: [url='.$mybb->settings['bburl'].'/'.$url.']'.$db->escape_string($new_thread['subject']).'[/url]',
    	'date' => time()));
}?>